<?php 

if(!defined('ABSPATH')) exit;
if(!current_user_can('edit_posts')) exit;
if(!$wpdb) $wpdb=new wpdb(DB_USER,DB_PASSWORD,DB_NAME,DB_HOST); else global $wpdb;
if(isset($_POST['period_range'])) $period_range=intval($_POST['period_range']); else $period_range=0;
$input_saved=0;

// Get Versions
  global $wp_version;
  global $dyt_version;
  global $dyt_pro_version;
  global $dyt_version_type;
  $dyt_db_version=get_option('dyt_db_version');
  $dyt_pro_version=0;
  $dyt_version_type='GPL';
  dyt_pro_path('dynamic-time','PRO'); dyt_pro_path('dynamic-time','pro');
  $get_version=$wpdb->get_results("SELECT @@version as version;",OBJECT);
  if($get_version) foreach($get_version as $row):$mysql_version=$row->version;endforeach;
  $db_config_mode=$wpdb->get_results("SELECT @@sql_safe_updates as mode;",OBJECT);
  if($db_config_mode) foreach($db_config_mode as $row):$config_mode=$row->mode;endforeach;

  function dyt_pro_path($slug,$type) {
    global $dyt_pro_version;
    global $dyt_version_type;
    $pro_path=str_replace($slug,"$slug-$type",plugin_dir_path( __FILE__ )).'pro_content.php';
    if(is_plugin_active("$slug-$type/pro_functions.php")) 
      if(file_exists($pro_path)) {include_once $pro_path; $dyt_pro_version=get_option('dyt_pro_version'); if($dyt_pro_version>0) $dyt_version_type='PRO';}
  }

// Sync Configuration
  if($dyt_version!=$dyt_db_version) dyt_activate(1); // Run dbDelta upgrade

// Update Configuration
  if(!empty($_POST['dyt_config_time']) && check_admin_referer('config_time','dyt_config_time')) {
    $prompt=intval($_POST['prompt']);
    $notes=intval($_POST['notes']);
    $period=intval($_POST['period']);
    $weekbegin=intval($_POST['weekbegin']);
    $currency=sanitize_text_field($_POST['currency']);
    if(version_compare($dyt_db_version,'3.4.8')>0) {
      $categoryon=intval($_POST['categoryon']);
      $categorylist=sanitize_text_field(preg_replace("/\n/",",",$_POST['categorylist']));
    } else {
      $categoryon=0;
      $categorylist='';
    }

    $dropdata=intval($_POST['dropdata']);
    if(isset($_POST['timeout'])) $timeout=intval($_POST['timeout']); else $timeout=-1;
    if(!empty($_POST['hide_survey'])) $hide_survey=intval($_POST['hide_survey']); else $hide_survey=0;
    $payroll_id=intval($_POST['payroll_id']);
    $wpdb->query("SET SQL_SAFE_UPDATES=0;");
    $delete_config=$wpdb->query("DELETE FROM {$wpdb->prefix}time_config;");
    $insert_config=$wpdb->query("INSERT INTO {$wpdb->prefix}time_config (Prompt,Notes,Period,WeekBegin,Payroll,Currency,DropData,Timeout,CategoryOn,CategoryList)VALUES('$prompt','$notes','$period','$weekbegin','$payroll_id','$currency','$dropdata','$timeout','$categoryon','$categorylist');");
    if(isset($hide_survey)) update_option('dyt_hide_survey',$hide_survey,'no');
    $input_saved++;
  }

// Update User
  if(!empty($_POST['dyt_config_user']) && check_admin_referer('config_user','dyt_config_user')) {
    $wp_userid=intval($_POST['wp_userid']);
    if(isset($_POST['user_period'])) $user_period=intval($_POST['user_period']); else $user_period=15;
    $rate=filter_var($_POST['rate'],FILTER_SANITIZE_NUMBER_FLOAT,FILTER_FLAG_ALLOW_FRACTION);
    $exempt=intval($_POST['exempt']);
    $supervisor_id=intval($_POST['supervisor_id']);
    $wpdb->query("SET SQL_SAFE_UPDATES=0;");
    $delete_user=$wpdb->query("DELETE FROM {$wpdb->prefix}time_user WHERE WP_UserID=$wp_userid;");
    $insert_user=$wpdb->query("INSERT INTO {$wpdb->prefix}time_user (WP_UserID,Period,Rate,Exempt,Supervisor)VALUES('$wp_userid','$user_period','$rate','$exempt','$supervisor_id');");
    $input_saved++;
  }

// Get Configuration
  $get_config=$wpdb->get_results("SELECT * FROM {$wpdb->prefix}time_config LIMIT 1;",OBJECT);
  $hide_survey=get_option('dyt_hide_survey');
  $dyt_user=0;
  $not_set='&#9888; Not Set';
  if(strpos($_SERVER['REQUEST_URI'],'dyt_user=')!==false) $dyt_user=intval($_GET['dyt_user']);
  if($get_config): 
    foreach($get_config as $row):
      $prompt=$row->Prompt;
      $notes=$row->Notes;
      $period=$row->Period;
      $weekbegin=$row->WeekBegin;
      $payroll_id=$row->Payroll;
      $currency=htmlentities($row->Currency);
      $dropdata=$row->DropData;
      $timeout=$row->Timeout;
      $categoryon=$row->CategoryOn;
      $categorylist=$row->CategoryList;
    endforeach;
    $dyt_setup=0;
  else:
    $prompt=-1;
    $notes=-1;
    $period=0;
    $weekbegin=-1;
    $payroll_id=-1;
    $currency='$';
    $dropdata=-1;
    $timeout=-1;
    $categoryon=-1;
    $categorylist='';
    $dyt_setup=1;
  endif;

// Get Users
  if($period_range===0) $condition="AND DATE_FORMAT(FROM_UNIXTIME(FLOOR((p.Date+1)*8.64e7)/1000),'%Y-%m-%d')>NOW()-INTERVAL 1.5 MONTH "; else $condition="";
  $get_users=$wpdb->get_results("
    SELECT u.*
    ,(SELECT user_email FROM {$wpdb->base_prefix}users WHERE ID=u.WP_UserID) email
    ,COALESCE(
      CONCAT((SELECT meta_value FROM {$wpdb->base_prefix}usermeta WHERE user_id=u.WP_UserID AND meta_key='first_name' AND LENGTH(meta_value)>0)
      ,(SELECT CONCAT(' ',meta_value) FROM {$wpdb->base_prefix}usermeta WHERE user_id=u.WP_UserID AND meta_key='last_name' AND LENGTH(meta_value)>0))
      ,(SELECT meta_value FROM {$wpdb->base_prefix}usermeta WHERE user_id=u.WP_UserID AND meta_key='nickname' AND LENGTH(meta_value)>0)
      ,(SELECT display_name FROM {$wpdb->base_prefix}users WHERE ID=u.WP_UserID)
      ,'[wp user deleted]'
    ) name
    ,COALESCE(
      CONCAT((SELECT meta_value FROM {$wpdb->base_prefix}usermeta WHERE user_id=u.Supervisor AND meta_key='first_name' AND LENGTH(meta_value)>0)
      ,(SELECT CONCAT(' ',meta_value) FROM {$wpdb->base_prefix}usermeta WHERE user_id=u.Supervisor AND meta_key='last_name' AND LENGTH(meta_value)>0))
      ,(SELECT meta_value FROM {$wpdb->base_prefix}usermeta WHERE user_id=u.Supervisor AND meta_key='nickname' AND LENGTH(meta_value)>0)
      ,(SELECT display_name FROM {$wpdb->base_prefix}users WHERE ID=u.Supervisor)
      ,'[wp user deleted]'
    ) supervisor_name
    ,Supervisor supervisor_id
    ,DATE_FORMAT(p.Submitted,'%Y-%m-%d') Submitted
    ,DATE_FORMAT(p.Approved, '%Y-%m-%d') Approved
    ,DATE_FORMAT(p.Processed,'%Y-%m-%d') Processed
    FROM {$wpdb->prefix}time_user u
    LEFT JOIN (
      SELECT WP_UserID, MAX(PeriodID) PeriodID
      FROM {$wpdb->prefix}time_period
      GROUP BY WP_UserID
    )m ON m.WP_UserID=u.WP_UserID
    LEFT JOIN {$wpdb->prefix}time_period p ON p.PeriodID=m.PeriodID
    WHERE u.WP_UserID>0
    $condition 
    ORDER BY Submitted DESC, Approved DESC, Processed DESC;
  ",OBJECT);
  $user_count=count($get_users);
  $sup_count=0;
  foreach($get_users as $row) { if($row->supervisor_id>0) $sup_count++; } ?>

<div id='input_saved'>Saved</div>
<table id='dyt_head' class='dyt_control' style='width:100%;border:none;'>
  <tr>
    <td align='left'>
      <img style='height:20px;' src='<?php echo plugins_url('/assets/DynamicTime.png',__FILE__);?>'>
      <div class='dyt_links'>
        <a href="#!" onclick="dyt_expand('dyt_setup');">Setup <span class="dashicons dashicons-admin-plugins"></span></a><br>
        <a href="#!" onclick="dyt_expand('dyt_pro');" <?php if(!current_user_can('manage_options')) echo "style='display:none'"; ?>><span class='caps'>Dynamic Time <span class='pro'>Pro</span><span class="dashicons dashicons-chart-line" style='color:#b71b8a'></span><span style='color:#1177aa;font-weight:bold'><br></a>
        <a href="#!" onclick="dyt_expand('dyt_diag');">Support & Diagnostics <span class="dashicons dashicons-admin-tools"></span></a>
      </div>
      <br><hr style='width:50%;float:left'><br>
      <?php if(isset($dyt_user)) if($dyt_user>0) { ?>
        <a id='dyt_return' href='#!' onclick="dyt_switchScreen('dyt_admin');"><div id='dyt_return_icon'></div> Return to Admin</a>
      <?php } ?>
    </td>
</table>
<?php 

if($dyt_user>0) {
  if(empty($_GET['sup'])) check_admin_referer('view_user','dyt_view_user');?>
  <style>#dyt_setup td{padding-left:3em}#dyt_admin{display:none}#dyt_admin,#dyt_cal_admin{-webkit-transition:all .2s;-moz-transition:all .2s;transition:all .2s}#dyt_survey,#dyt_survey_button{display:none}#dyt_cal_admin #dyt_form{margin:0;width:99%}</style>
  <div id='dyt_cal_admin'>
    <?php echo do_shortcode('[dynamicTime]');?>
  </div>
<?php } ?>

<style>
#dyt_pro ul>li:before{padding:0;margin:0;content:'\276D';font-weight:700;color:#b71b8a;padding-right:6px}
a:focus{box-shadow:none}
#dyt_admin .button{width:100%;font-size:.9em;font-weight:normal}
#dyt_admin .dashicons-dismiss{cursor:pointer}
#dyt_head .dyt_links{float:right;text-align:right}
#dyt_head .dyt_links a{line-height:1.8em}
#dyt_admin .dyt_control .dyt_link{display:block;background:#0073aa;color:#FFF;border-radius:3px;padding:1em 3em;text-align:center;font-weight:normal}
#dyt_admin .dyt_control .dyt_link:hover{background:#b71b8a;color:#FFF;text-decoration:none}
#dyt_admin .spin:hover,#dyt_admin .budge,#dyt_admin .dyt_expand{-webkit-transition:all .5s;-moz-transition:all .5s;transition:all .5s}
#dyt_admin .dyt_expand{display:none;opacity:0;max-height:0;padding:2em}
#dyt_admin #dyt_setup{font-size:1.2em}
#dyt_admin #dyt_setup li{margin:1em 0}
#dyt_admin .setup_order{font-size: 2em;vertical-align:text-bottom;font-weight:bold;color:#ce299e}
#dyt_admin table th{color:#0073AA;padding:0 .5em}
#dyt_admin table td{overflow:hidden;white-space:nowrap;padding:.3em 1em}
#dyt_admin table .even{background:#F6F6F6}
#dyt_admin table .odd{background:#E8E8E8;color:#666}
#dyt_admin table tr:hover{background:#FFF;color:#0073AA}
#dyt_admin table .col_name{color:#777}
#dyt_admin table .dyt_disable{color:gray;opacity:.7;pointer-events:none}
.caps{color:#17a;font-weight:700;font-variant-caps:petite-caps}
#dyt_admin .attn{color:#FFF;border-radius:3px;background:#b71b8a;color:#fff;padding:1em;margin:1em 0}
#dyt_admin .spin:hover{transform:rotate(180deg)}
#dyt_admin .view{cursor:pointer;text-decoration:none}
#dyt_admin tr:hover>td>.budge{margin-right:-.1em}
#dyt_admin .dyt_new{padding:1em;background:#b71b8a;color:#fff;border-radius:3px;margin:11em 0 1em 0;width:50%}
#dyt_admin .dyt_new:after{border-width: 14px 7px 0;border-color:#b71b8a transparent;content:'';position:absolute;border-style:solid;display:block;width:0;margin:1em 0 0}
#dyt_admin .goog-te-gadget-simple{border:1px solid #888}
</style>

<div id='dyt_admin'>
  <form class='dyt_form' name='timeconfig' id='timeconfig' method='post' accept-charset='UTF-8 ISO-8859-1' action='<?php echo get_admin_url(null,'admin.php?page=dynamic-time');?>&wp=0'>
    <?php echo wp_nonce_field('config_time','dyt_config_time');
    if(current_user_can('manage_options')) { ?>
    <table id='timesettings' class='dyt_control'>
      <tr style='background:transparent;color:#1177aa;font-weight:bold'><th align='left'><span class="dashicons dashicons-admin-generic"></span> Settings<hr></th></tr>
      <tr>
        <td nowrap>
          <br>Translate these settings
          <div id="google_translate_element"></div>
          <script type="text/javascript">function googleTranslateElementInit(){new google.translate.TranslateElement({pageLanguage:'en',layout:google.translate.TranslateElement.InlineLayout.SIMPLE},'google_translate_element');}</script>
          <script type="text/javascript" src="https://translate.google.com/translate_a/element.js?cb=googleTranslateElementInit"></script>
          <br>
        </td>
      </tr>
      <tr><td style='pointer-events:none'>Hover over &#8505; to display more information.</td></tr>
      <tr>
        <td nowrap>
          <select name='prompt' id='prompt' onchange="dyt_config('timeconfig',this.id,this.selectedIndex);" title='Select a method of time entry.'>
            <option value='' disabled  <?php if($prompt<0) echo 'selected';?>>Select Entry Type
            <option value='0' <?php if($prompt==0) echo 'selected';?> title="One total field per day.">Simple &#8505;
            <option value='1' <?php if($prompt==1) echo 'selected';?> title="Multiple In/Out fields per day.">Itemized &#8505;
            <option value='3' <?php if($prompt==3) echo 'selected';?> title="Punch In/Out Only (Only admins can manually adjust time).">Punch Only &#8505;
            <option value='2' <?php if($prompt==2) echo 'selected'; if($dyt_pro_version<=0) echo 'disabled'; ?> title="AUTO Entry - records time automatically (This is practical when a user is active in WordPress throughout the workday).">Auto Entry (PRO) &#8505;
          </select>
          <span id='prompt_sel' class='sel_status'><?php if($prompt<0) echo $not_set;?></span>

          <select name='timeout' id='timeout' onchange="dyt_config('timeconfig',0,0);" style='<?php if($dyt_pro_version>0 && $prompt>1) echo "display:block;margin:.5em 0 0"; else echo "display:none"; ?>' title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">
            <option value='' disabled <?php if($timeout<0) echo 'selected';?>>Session Timeout &#8505;
            <option value='10' <?php if($timeout==10) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">10 minutes
            <option value='20' <?php if($timeout==20) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">20 minutes
            <option value='30' <?php if($timeout==30) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">30 minutes (recommended)
            <option value='40' <?php if($timeout==40) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">40 minutes
            <option value='60' <?php if($timeout==60) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">1 hour
            <option value='90' <?php if($timeout==90) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">1.5 hours
            <option value='120' <?php if($timeout==120) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">2 hours
            <option value='240' <?php if($timeout==240) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">4 hours
            <option value='360' <?php if($timeout==360) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">6 hours
            <option value='480' <?php if($timeout==480) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">8 hours
            <option value='600' <?php if($timeout==600) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">10 hours
            <option value='720' <?php if($timeout==720) echo 'selected';?> title="If user inactivity in exceeds this time, Auto Entry will create an additional in/out period when activity resumes.">12 hours
          </select>
        </td>
      </tr>
      <tr>
        <td nowrap>
          <select name='notes' id='notes' onchange="dyt_config('timeconfig',this.id,this.selectedIndex);" title='Enable the option to enter notes on each time entry.'>
            <option value='' disabled  <?php if($notes<0) echo 'selected';?> title='Enable the option to enter notes on each time entry.'>Select Note Display &#8505;
            <option value='1' <?php if($notes==1) echo 'selected';?> title="Display optional note field.">Display Notes &#8505;
            <option value='0' <?php if($notes==0) echo 'selected';?> title="Hide note field.">No Notes &#8505;
          </select>
          <span id='notes_sel' class='sel_status'><?php if($notes<0) echo $not_set;?></span>
        </td>
      </tr>
      <?php if(isset($_GET['updated'])) {?>
        <div class='dyt_new'><span class="dashicons dashicons-controls-play"></span> Additional Category in <span class='caps' style='color:#FFF'>PRO</span> <span style='font-style:italic;font-size:.9em'> Now enable an additional dropdown for categorizing time.</span>
          <?php if($dyt_pro_version<=0) { ?><br><br><a href='#!' style='color:#FFF' onclick="dyt_expand('dyt_pro');">Upgrade to <span class='caps' style='color:#FFF'>PRO</span> for this feature and more!</a><?php } ?>
        </div>
      <?php } ?>
      <tr>
        <td nowrap>
          <select name='categoryon' id='categoryon' onchange="dyt_config('timeconfig',this.id,this.selectedIndex);" title='Enable additional dropdown for categorizing time.'>
            <option value='' disabled  <?php if($categoryon<0) echo 'selected';?>>Additional Category (PRO) &#8505;
            <option value='1' <?php if($categoryon==1) echo 'selected'; if($dyt_pro_version<=0) echo 'disabled';?> title="Display optional category dropdown.">Enable Categories &#8505;
            <option value='0' <?php if($categoryon==0) echo 'selected';?> title="Hide category dropdown.">Disable Categories &#8505;
          </select>
          <span id='categoryon_sel' class='sel_status'><?php if($categoryon<0) echo $not_set;?></span>
        </td>
      </tr>
      <tr <?php if(!$categoryon>0) echo "style='display:none'"; ?>>
        <td nowrap>
          <textarea name='categorylist' id='categorylist' onchange="dyt_config('timeconfig',this.id,this.selectedIndex);" style='width:100%;height:5em;background:#f6f6ff' title="List categories to appear in the dropdown (separated by comma or line)." placeholder='List categories&#10;separated,by,comma&#10;or new line.'><?php echo str_replace(',',"\n",$categorylist); ?></textarea>
          <span id='categorylist_sel' class='sel_status'><?php if($categorylist<0) echo $not_set;?></span>
        </td>
      </tr>
      <tr>
        <td nowrap>
          <select name='period' id='period' onchange="dyt_config('timeconfig',this.id,this.selectedIndex);" title='Select the length of pay period.'>
            <option value='' disabled <?php if($period==0) echo 'selected';?>>Select Pay Period
            <option value='7'  <?php if($period==7 ) echo 'selected';?> title='Pay periods are every week (52 per year).'>Weekly Pay Period &#8505;
            <option value='14' <?php if($period==14) echo 'selected';?> title='Pay periods are in two week groups (26 per year).'>BiWeekly Pay Period &#8505;
            <option value='15' <?php if($period==15) echo 'selected';?> title='Pay periods are twice per calendar month (24 per year).'>Semi-Monthly Pay Period &#8505;
            <option value='30' <?php if($period==30) echo 'selected';?> title='Pay periods are every calendar month (12 per year).'>Monthly Pay Period &#8505;
            <option value='-1' <?php if($period==-1) echo 'selected';?> title='Pay period differs between users.'>Manage on User Level &#8505;
          </select>
          <span id='period_sel' class='sel_status'><?php if($period==0) echo $not_set;?></span>
        </td>
      </tr>
      <tr>
        <td nowrap>
          <select name='weekbegin' id='weekbegin' onchange="dyt_config('timeconfig',this.id,this.selectedIndex);" title='Select the day a week begins.'>
            <option value='' disabled <?php if($weekbegin<0) echo 'selected';?>>Select Week Begin &#8505;
            <option value='0' <?php if($weekbegin==0 && $dyt_setup==0) echo 'selected';?>>Week Begins Sunday
            <option value='1' <?php if($weekbegin==1) echo 'selected';?>>Week Begins Monday
            <option value='2' <?php if($weekbegin==2) echo 'selected';?>>Week Begins Tuesday
            <option value='3' <?php if($weekbegin==3) echo 'selected';?>>Week Begins Wednesday
            <option value='4' <?php if($weekbegin==4) echo 'selected';?>>Week Begins Thursday
            <option value='5' <?php if($weekbegin==5) echo 'selected';?>>Week Begins Friday
            <option value='6' <?php if($weekbegin==6) echo 'selected';?>>Week Begins Saturday
          </select>
          <span id='weekbegin_sel' class='sel_status'><?php if($weekbegin<0) echo $not_set;?></span>
        </td>
      </tr>
      <tr>
        <td nowrap>
          <select name='payroll_id' id='payroll_id' onchange="dyt_config('timeconfig',this.id,this.selectedIndex);" title='A supervisor receives notification when a pay period is submitted. Payroll (admins) receives notification when a pay period is approved. If a supervisor is not assigned, Payroll will receive both types of notifications.'>
            <option value='0' disabled <?php if($payroll_id<0) echo 'selected';?> title='A supervisor receives notification when a pay period is submitted. Payroll (admins) receives notification when a pay period is approved. If a supervisor is not assigned, Payroll will receive both types of notifications.'>Payroll Notifications &#8505;
            <option value='0' <?php if($payroll_id==0) echo 'selected';?>>No Notification
            <?php echo dyt_user_dropdown('payroll',$payroll_id);?>
          </select>
          <span id='payroll_id_sel' class='sel_status'><?php if($payroll_id<0) echo $not_set;?></span>
        </td>
      </tr>
      <tr>
        <td nowrap>
          <select name='dropdata' id='dropdata' onchange="dyt_config('timeconfig',this.id,this.selectedIndex);" title='Keep Data Safe will retain user entries and configuration data even if the plugin is uninstalled.'>
            <option value='' disabled <?php if($dropdata<0) echo 'selected';?> title='Keep Data Safe will retain user entries and configuration data even if the plugin is uninstalled.'>Uninstall Option &#8505;
            <option value='0' <?php if($dropdata===0) echo 'selected';?> title='No plugin data will be deleted.'>Keep Data Safe &#8505;
            <option value='1' <?php if($dropdata==1) echo 'selected';?> title='All data will be deleted on uninstall.'>Delete All Plugin Data &#8505;
          </select>
          <span id='dropdata_sel' class='sel_status'><?php if($dropdata<0) echo '&#9888; Not Set';?></span>
        </td>
      </tr>
      <tr>
        <td nowrap>
          <div style='width:200px;text-align:right'>Currency 
            <input type='text' name='currency' id='currency' placeholder='$' title='Currency Symbol' pattern=".{1,5}" required title="1 to 5 characters" style='max-width:5em' value='<?php if(empty($currency) || $dyt_setup>0) echo '$'; else echo $currency;?>' onchange="if(this.value>0) dyt_config('timeconfig',this.id,this.selectedIndex);">
          </div>
        </td>
      </tr>
    </table>
    <?php } 

    if($dyt_setup==0) { ?>
    <input type='hidden' name='hide_survey' id='hide_survey' value=<?php if($hide_survey==1) echo 1; else echo 0; ?>>
    <?php } ?>
  </form>

  <div id='dyt_diag' class='dyt_control dyt_expand' style='float:right'>
    <span style='color:#1177aa;font-weight:bold'><span class="dashicons dashicons-admin-tools"></span> Support & Diagnostics</span>
    <a onclick="dyt_expand('dyt_diag');" style='text-decoration:none;float:right'><span class="dashicons dashicons-dismiss"></span></a><hr>
    <br>
    <div id='dyt_diag_data'>
      <b>Configuration</b><br>
      Host <?php echo $_SERVER['HTTP_HOST'].'@'.$_SERVER['SERVER_ADDR']; ?><br>
      Path <?php echo substr(plugin_dir_path( __FILE__ ),-33);?><br>
      WP <?php echo $wp_version; if(is_multisite()) echo 'multi'; ?><br>
      PHP <?php echo phpversion();?><br>
      MYSQL <?php echo $mysql_version; if(!empty($config_mode)) echo $config_mode; ?><br>
      Theme <?php $pt=wp_get_theme(get_template()); echo $pt->Name.' '.$pt->Version; $ct=wp_get_theme(); if($pt->Name!==$ct->Name) echo ', '.$ct->Name.' '.$ct->Version;?><br>
      Dynamic Time <?php echo $dyt_version.' '.$dyt_version_type.' '.$dyt_pro_version; ?><br>
      Dynamic Time db <?php echo $dyt_db_version;?><br>
      <br>
      <b>Settings</b><br>
      Prompt <?php echo $prompt;?><br>
      Notes <?php echo $notes;?><br>
      Category <?php echo $categoryon; echo '('.count(explode(',',$categorylist)).')'; ?><br>
      Period <?php echo $period;?><br>
      Week Begin <?php echo $weekbegin;?><br>
      Payroll <?php echo $payroll_id;?><br>
      Drop Data <?php echo $dropdata;?><br>
      Currency <?php echo $currency;?><br>
      Survey <?php echo $hide_survey;?><br>
      Users <?php echo $user_count;?><br>
      Sups <?php echo $sup_count;?><br>
    </div>
    <br><input type='button' class='button caps' style='width:100%' value='copy diagnostics' id='dyt_diag_copy' onclick="dyt_copy('dyt_diag_data',this.id);">
    <div class='caps' style='color:#1177aa;font-weight:normal;padding:1em'>Please provide diagnostics when submitting issues.</div>
    <a class='dyt_link caps' href="https://richardlerma.com/plugins/" target='_blank'>contact support</a>
  </div>

  <div id='dyt_pro' class='dyt_control dyt_expand' style='float:right'>
    Get <span class='caps'>Dynamic Time <span class='pro'>Pro</span></span><span class="dashicons dashicons-chart-line" style='color:#b71b8a;vertical-align:text-bottom'></span>
    <a onclick="dyt_expand('dyt_pro');" style='text-decoration:none;float:right'><span class="dashicons dashicons-dismiss"></span></a><hr>
    <br>
      <strong>Subscription Features</strong>
      <ul style='padding:unset'>
        <li>Additional dropdown for categorizing time.
        <li>CSV export by timeframe
        <li>Copy & paste data into Excel or spreadsheet
        <li>Table-based overview. Filter by employee and pay period.
        <li>View and search employee note fields on one page.
        <li>Auto Entry records time automatically if user is active in WordPress.
        <li>Dedicated support with guaranteed 12 hour response time (~6 hour average)
        <li>PRO add-on installs quickly next to existing plugin
      </ul>
    <?php if($dyt_pro_version<=0) { ?><div style='line-height:3em'><div class='caps'>To upgrade, please agree to the following:</div><input id='pro_terms' type='checkbox'>I've <a href='<?php echo get_admin_url(null,'update-core.php');?>' target='_blank'>checked for updates</a>. My existing version of Dynamic Time is current.</div><?php } ?>
    <div><input id='pro_cmp' type='checkbox' <?php if($dyt_pro_version>0) echo 'checked disabled'; ?>>I understand the PRO <a href='https://richardlerma.com/dyt-terms/' target='_blank'>terms & conditions</a>.</div>

    <?php if($dyt_pro_version!==0) { ?>
      <div class='attn caps' style='font-weight:normal'><span class='dashicons dashicons-yes'></span> Thanks for using Pro!</div>
      <input type='button' class='button' value='Check for Updates' onclick="window.location.href='<?php echo get_admin_url(null,'admin.php?page=dynamic-time&pro_update=1');?>';"><?php 
    }
    if($dyt_pro_version<=0) { ?><a onclick="if(document.getElementById('pro_terms').checked && document.getElementById('pro_cmp').checked) return true; else {alert('Please verify your existing version is current and agree to terms & conditions'); return false;}" class='dyt_link caps' style='margin-top:1em' href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=UZDNT7Q8KD8P6" target='_blank'>Purchase Pro</a><br><?php } ?>
  </div>

  <div id='dyt_setup' class='dyt_control dyt_expand' style='float:left'>
    <span style='color:#0073AA;font-weight:bold'><span class="dashicons dashicons-admin-plugins"></span> Get Started</span>
    <a onclick="alert('Setup instructions will persistently display until more than one user has created a time entry.'); dyt_expand('dyt_setup');" style='text-decoration:none;float:right'><span class="dashicons dashicons-dismiss"></span></a><hr>
    <ul style='margin-left:1em'>
      <li><span class='setup_order'>&#10112;</span> Customize your organization's setup in the <b>Settings</b> module.
      <li><span class='setup_order'>&#10113;</span> <a target='_blank' href='<?php echo str_replace('&amp;','&',wp_nonce_url(get_admin_url(null,'admin.php?page=dynamic-time'),'view_user','dyt_view_user')).'&dyt_user='.get_current_user_id();?>'>Open your timesheet</a>. Press save. All users must save a time period to show up in <b>User Entries</b>.
      <li><span class='setup_order'>&#10114;</span> Refresh this page <a href='#!' onclick="if(window.location.href.indexOf('dyt_view_user')>0) window.location='<?php echo get_admin_url(null,'admin.php?page=dynamic-time');?>'; else location.reload(true);" title='Refresh'><span style='opacity:.5' class="spin dashicons dashicons-update"></span></a> to see your new entry.
      <li><span class='setup_order'>&#10115;</span> To access Dynamic Time outside of the WordPress dashboard, publish shortcode <span title='Click to copy.&#013;When published, the shortcode will automatically redirect to the login form if a user is not logged in.'><a id='dyt_shortcode' style='display:inline-block' href='#!' onclick="dyt_copy(this.id,this.id);">[dynamicTime]</a><span class="dashicons dashicons-editor-help"></span></span>. 
      <li title='&#8226; Employees will only see their timesheet on this page.&#013;&#8226; Only you (an administrator) and assigned Supervisors will be able to see other timesheets.'><span class='setup_order'>&#10116;</span> Users with WP dashboard access can visit this page<span class="dashicons dashicons-editor-help"></span> to enter time. (Only Admins see all employees)
    </ul>
    <br><span class="dashicons dashicons-warning" style='color:orange'></span> Important: Dynamic Time may perform unexpectedly or inaccurately if accessed in private/incognito browsing mode.<br>
    <br><span class="dashicons dashicons-format-status"></span> Questions or concerns? View <a href='#!' onclick="dyt_expand('dyt_diag');">Support & Diagnostics</a>
  </div>

  <?php if($dyt_pro_version>0 && current_user_can('edit_posts') && function_exists('dyt_pro')) @dyt_pro($prompt,$notes,$categoryon); 
    if($user_count>0 || $dyt_setup<1) { ?>
    <table id='usersettings' cellspacing='0' cellpadding='0' class='dyt_control'>
      <tr style='background:transparent'>
        <th colspan='<?php if($period<0) echo '8'; else echo '7'; ?>' align='left'>
          <span class="dashicons dashicons-clock"></span> User Entries &nbsp;
          <form style='display:inline' method='post' accept-charset='UTF-8 ISO-8859-1' action='<?php echo get_admin_url(null,'admin.php?page=dynamic-time');?>'>
            <select style='height:2em;min-width:20em;font-size:.9em;border:none;font-weight:normal' name='period_range' onchange="this.form.submit();"><option value='0' selected>Users Active in Last Month<option value='1' <?php if($period_range>0) echo 'selected'; ?>>Display All</select>
          </form><hr>
        </th>
        <th><a href='#!' onclick="if(window.location.href.indexOf('dyt_view_user')>0) window.location='<?php echo get_admin_url(null,'admin.php?page=dynamic-time');?>'; else location.reload(true);" title='Refresh'><span style='float:right;opacity:.5;margin:-1.5em -1em 0 0' class="spin dashicons dashicons-update"></span></a></th>
      </tr>
      
      <tr style='background:transparent'>
        <th class='col_name'>Name</th>
        <th class='col_name dyt_rate'>Rate</th>
        <th class='col_name'>Status</th><?php 
        if($period<0) { ?><th class='col_name'>Period</th><?php } ?>
        <th class='col_name'>Supervisor</th>
        <th class='col_name'>Submitted</th>
        <th class='col_name'>Approved</th>
        <th class='col_name'>Processed</th>
        <th class='col_name' align='right' style='min-width:70px;'>View</th>
      </tr><?php 

    $row_id=1; 
    foreach($get_users as $row) {
      if(strpos($row->name,'[wp ')!==false) $disabled="class='dyt_disable'"; else $disabled='';
      $uid=$row->WP_UserID;
      $uname=ucwords(preg_replace('/[^A-Za-z0-9. -]/','',$row->name));
      $sid=$row->supervisor_id;
      $sname=ucwords(preg_replace('/[^A-Za-z0-9. -]/','',$row->supervisor_name));
      $cid=dyt_userid();
      if($cid!=$sid && $cid!=$uid && !current_user_can('list_users')) continue; ?>

      <form class='form' name='userconfig' id='userconfig<?php echo $uid;?>' method='post' accept-charset='UTF-8 ISO-8859-1' action='<?php echo get_admin_url(null,'admin.php?page=dynamic-time');?>&wp=0'>
        <?php echo wp_nonce_field('config_user','dyt_config_user');?>
        <input type='hidden' name='wp_userid' value='<?php echo $uid;?>'>
        <tr class='<?php if($row_id % 2===0) echo 'odd'; else echo 'even';?>'>

          <td nowrap>
            <a title="Edit Account" style='opacity:.3' target='_blank' href='../wp-admin/user-edit.php?user_id=<?php echo $uid;?>' <?php echo $disabled;?>> &#128100;</a> &nbsp;
            <a title="Email <?php echo $uname;?>" style='font-size:1.3em;text-decoration:none' target='_blank' href='mailto:<?php echo $row->email;?>' <?php echo $row->email;?>' <?php echo $disabled;?>> &#9993;</a> &nbsp;
            <a title="View Timecard" style='font-size:1.2em' class='view' <?php echo $disabled;?> onclick="dyt_switchScreen('<?php echo $uid;?>');"><?php echo $uname;?></a>
          </td>

          <td nowrap class='dyt_rate'>
            <?php if(!$row->Rate>0) echo "<span title='Enter Hourly Rate'>&#9888;</span>"; else  echo $currency; ?>
            <input type='number' <?php if($cid==$uid && !current_user_can('list_users')) echo "style='pointer-events:none'"; ?> required step='0.01' min='0' max='150' value='<?php echo $row->Rate;?>' name='rate' class='rate' placeholder='Hourly Rate' onchange="dyt_config('userconfig<?php echo $uid;?>');">
          </td>

          <td nowrap>
            <select required name='exempt' onchange="dyt_config('userconfig<?php echo $uid;?>');">
              <option disabled  <?php if(!isset($row->Exempt)) echo 'selected';?>>Select Status
              <option value='0' <?php if($row->Exempt===0) echo 'selected';?> title='Time and a half for hours worked in excess of 40/week.'>Overtime Eligible (Standard FLSA &#8505;)
              <option value='-1' <?php if($row->Exempt<0) echo 'selected';?> title='Time and a half for hours worked in excess of 8/day OR 40/week.'>Overtime Eligible (California &#8505;)
              <option value='1' <?php if($row->Exempt==1) echo 'selected';?> title='Not overtime eligible'>Exempt &#8505;
            </select>
            <?php if(!isset($row->Exempt)) echo '<br>&#9888; Status Not Set';?>
          </td><?php 

          if($period<0) { ?>
            <td nowrap>
              <select name='user_period' id='user_period' onchange="dyt_config('userconfig<?php echo $uid;?>');">
                <option value='' disabled>Select Pay Period
                <option value='7'  <?php if($row->Period==7 ) echo 'selected';?> title='Pay periods are every week (52 per year).'>Weekly Pay Period &#8505;
                <option value='14' <?php if($row->Period==14) echo 'selected';?> title='Pay periods are in two week groups (26 per year).'>BiWeekly Pay Period &#8505;
                <option value='15' <?php if($row->Period==15) echo 'selected';?> title='Pay periods are twice per calendar month (24 per year).'>Semi-Monthly Pay Period &#8505;
                <option value='30' <?php if($row->Period==30) echo 'selected';?> title='Pay periods are every calendar month (12 per year)'>Monthly Pay Period &#8505;
              </select>
              <?php if(!isset($row->Period)) echo '<br>&#9888; Period Not Set';?>
            </td><?php 
          } ?>

          <td nowrap>
            <select value='<?php echo $sid;?>' <?php if(!current_user_can('list_users')) echo "style='pointer-events:none'"; else echo "onchange=\"dyt_config('userconfig$uid');\"";?> name='supervisor_id' title="<?php echo $sname;?>">
              <option value='0' disabled title='A supervisor will receive notification when a pay period is submitted.'>Supervisor &#8505;
              <option value='0' <?php if(!$sid>0) echo 'selected';?>>None
              <?php echo dyt_user_dropdown('supervisor',$sid);?>
            </select>
          </td>

          <td nowrap align='right'><a class='view' onclick="dyt_switchScreen('<?php echo $uid;?>');"><?php echo $row->Submitted;?></a></td>
          <td nowrap align='right'><a class='view' onclick="dyt_switchScreen('<?php echo $uid;?>');"><?php echo $row->Approved;?></a></td>
          <td nowrap align='right'><a class='view' onclick="dyt_switchScreen('<?php echo $uid;?>');"><?php echo $row->Processed;?></a></td>
          <td align='right'><a title='View Timecard' class='view budge' style='font-size:2em;' onclick="dyt_switchScreen('<?php echo $uid;?>');">&#10162;</a></td>
        </tr>
      </form><?php 
      $row_id++;
    }} else echo "<style>#usersettings{display:none}</style>"; ?>
  </table>

  <?php if($dyt_setup==0 && $user_count>0 && $hide_survey!=1) { ?>
    <div id='dyt_survey' class='dyt_control'>
      <a onclick="
        if(!confirm('Permanently hide the Review prompt?')) return;
        if(document.getElementById('hide_survey')) {
          if(document.getElementById('hide_survey').value==1) document.getElementById('hide_survey').value=0;
          else document.getElementById('hide_survey').value=1;
        }
        if(document.getElementById('timeconfig')) document.getElementById('timeconfig').submit();">
      <span style='text-decoration:none;float:right' class="dashicons dashicons-dismiss"></span>
      </a>
      <div class='caps'>Liking Dynamic Time?</div>
      <a href='https://wordpress.org/support/plugin/dynamic-time/reviews/#new-post' style='color:#ffb900;text-decoration:none' target='_blank'>
        <div style='margin:.5em 0 1.5em 0;color:#ffb900'>
          <span style='color:#ccc;font-size:.8em'>Leave a Quick Review</span><br>
          <span class="dashicons dashicons-star-filled"></span>
          <span class="dashicons dashicons-star-filled"></span>
          <span class="dashicons dashicons-star-filled"></span>
          <span class="dashicons dashicons-star-filled"></span>
          <span class="dashicons dashicons-star-filled"></span>
        </div>
      </a>
      Have a question or concern?<br><br>
      <a href='#!' class='dyt_link caps' onclick="dyt_expand('dyt_diag');dyt_survey.style.display='none';">open support menu</a>
    <?php } ?>
  </div>

<script type='text/javascript'>
  var dyt_user='<?php echo $dyt_user;?>';<?php 
  if($dyt_pro_version>0) {$pro=get_option('dyt_pro'); if($pro=='new') update_option('dyt_pro','yes','no');} else $pro='no';
  if($pro=='new' || ($dyt_pro_version<=0 && isset($_GET['updated']) && function_exists('gzcompress'))) { ?>
    var dyt_version_Interval=setInterval(function() {
      if(document.readyState==='complete') {clearInterval(dyt_version_Interval);dyt_expand('dyt_pro');window.location.hash='#dyt_pro';}
    },200);<?php 
  }

  if(!$dyt_user>0 && ($dyt_setup>0 || $user_count<2)) { ?>
    var dyt_setup_Interval=setInterval(function() {
      if(document.readyState==='complete') {clearInterval(dyt_setup_Interval);dyt_expand('dyt_setup');}
    },200);
  <?php } ?>

  if('<?php echo $input_saved;?>'>0) {
    save_msg=document.getElementById('input_saved');
    save_msg.style.opacity=1;
    save_msg.style.display='block';
    save_msg.innerHTML='Saved';
    setTimeout(function(){save_msg.style.opacity=0;},2000);
    setTimeout(function(){save_msg.style.display='none';},3000);
  }

  function dyt_switchScreen(screen) {
    var user;
    if(screen!='dyt_admin') {user=screen; screen='dyt_cal_admin';}
    if(dyt_user!=user && screen=='dyt_cal_admin') {
      dyt_config('userconfig');
      var url="<?php echo str_replace('&amp;','&',wp_nonce_url(get_admin_url(null,'admin.php?page=dynamic-time'),'view_user','dyt_view_user')); ?>";
      window.location=url+"&dyt_user="+user;
      return;
    }
    if(summary_updated>0 && screen=='dyt_admin') if(!confirm('You have unsaved changes, are you sure you would like to exit?')) return false;
    document.getElementById('dyt_cal_admin').style.opacity='0';
    document.getElementById('dyt_admin').style.opacity='0';
    setTimeout(function(){
      document.getElementById('dyt_return').style.display='none';
      document.getElementById('dyt_cal_admin').style.display='none';
      document.getElementById('dyt_admin').style.display='none';
    },100);
    
    setTimeout(function(){
      document.getElementById(screen).style.display='block';
      if(screen=='dyt_cal_admin')document.getElementById('dyt_return').style.display='block';
      setTimeout(function(){document.getElementById(screen).style.opacity='1';},100);
    },101);
  }

  function dyt_config(fid,sid,sel_index) {
    var setup_saved='<?php echo $dyt_setup;?>';
    if(fid=='timeconfig') {
      if(sel_index>0) document.getElementById(sid+'_sel').innerHTML='&#10004';
      if(document.getElementById('timeconfig').innerHTML.indexOf('Not Set')!=-1) return false;
    }
    document.getElementById('dyt_admin').style.opacity='.3';
    
    if(document.getElementById('dyt_head')) var dyt_head=document.getElementById('dyt_head');
    if(dyt_head) dyt_head.innerHTML=dyt_head.innerHTML+"<progress id='loading' style='float:left;width:100%;' max='100'></progress>";
    if(setup_saved>0) { setTimeout(function(){ if(document.getElementById(fid)) document.getElementById(fid).submit(); },2000);}
    else if(document.getElementById(fid)) document.getElementById(fid).submit();
  }

  function dyt_copy(content_id,button_id) {
    document.getElementById(button_id).disabled=true;
    var contents=document.getElementById(content_id).innerHTML;
    
    if(contents.indexOf('&#9986;')>0) return false;
    var tmpEl;
    var copy_temp='copy_temp'+Math.floor((Math.random()*1000)+1);
    
    tmpEl=document.createElement(copy_temp);
    tmpEl.style.opacity=0;
    tmpEl.style.position="absolute";
    tmpEl.style.pointerEvents="none";
    tmpEl.style.zIndex=-1;
    tmpEl.innerHTML=contents;
    document.body.appendChild(tmpEl);

    var range=document.createRange();
    range.selectNode(tmpEl);
    
    var w=window.getSelection();
    if(w.rangeCount>0) w.removeAllRanges();
    w.addRange(range);

    if(!document.execCommand("copy")) {
      alert('Unable to auto-copy this content.\nPlease copy this content manually.');
      return false;
    }
    document.body.removeChild(tmpEl);
    
    var confirm="<div class='caps' style='position:absolute;background:#17A;color:#DDD;padding:2em;border-radius:3px;box-shadow:0px 3px 5px #888;z-index:99'>&#9986; Copied to clipboard!</div>";
    var opaque="<div style='opacity:.3;height:100%;width:100%;'>"+contents+"</div>";
    
    document.getElementById(content_id).innerHTML=confirm+opaque;
    
    setTimeout(function(){
      document.getElementById(content_id).innerHTML=contents;
      document.getElementById(button_id).disabled=false;
    },2000);
  }

  function dyt_expand(id) {
    if(!document.getElementById(id)) return false;
    var is_admin=1; if(document.getElementById('dyt_return')) {if(document.getElementById('dyt_return').style.display!='none') is_admin=0;}
    var target=document.getElementById(id);
    if(is_admin==0) dyt_switchScreen('dyt_admin');
    if(target.style.opacity==1 && is_admin==0) {target.style.opacity='0'; dyt_expand(id); return;}
    if(target.style.opacity!=1) {
      target.style.display='block';
      setTimeout(function(){
        target.style.opacity='1';
        target.style.maxHeight='99em';
        target.style.padding=target.style.overflow='';
      },10);
    } else {
      target.style.maxHeight=target.style.opacity=target.style.padding='0';
      target.style.overflow='none';
      setTimeout(function(){target.style.display='none';},500);
    }
  }
</script>